#ifndef FTAPI_H
#define FTAPI_H

/*******************************************************************************
	FTAPI
	FastTrack Access API
	c)2003-13 List SpA
*******************************************************************************/


/*******************************************************************************
	Comments Tags:

	deprecated	: not to be used. In case of function Fun there is an equivalent 
				  FunExt available.
	superseded	: not to be used, using it will result in an error.
	Vxyz		: added, starting from the x.y.z release version.
*******************************************************************************/

 
#ifdef FTDLL_EXPORTS
	#define FT_API __declspec(dllexport)
#else
	#define FT_API __declspec(dllimport)
#endif

//#if defined(WIN32) && !defined(NODLL)
//	#define 0
//#else
//	#define FT_API
//#endif


#define FT_OFFSET(Type, Field)			((unsigned long)&((Type*)0)->Field)


#define FTTrue							1
#define FTFalse							0

#define FTKEY_MAXLEN					(256)

/* Return codes */

#define FTOK							( 0L)
#define FTDoubleInitError				(-1L)
#define FTInternalError					(-2L)
#define FTInitError						(-3L)
#define FTCloseError					(-4L)
#define	FTInvalidIPAddress				(-5L)
#define FTInvalidIPPort					(-6L)
#define	FTNoServer						(-7L)
#define	FTTransportError				(-8L)
#define FTInvalidUserType				(-9L)
#define	FTInvalidUserName				(-10L)
#define FTInvalidPassword				(-11L)
#define FTInvalidRevision				(-12L)
#define FTInvalidCID					(-13L)
#define FTAlreadyLog					(-14L)
#define	FTInvalidConvIdError			(-15L)
#define	FTGenericError					(-16L)
#define FTInvalidSubscribeTypeError		(-17L)
#define	FTInvalidClassIDError			(-18L)
#define	FTDoubleSubscription			(-19L)
#define	FTNoSubscribedClassError		(-20L)
#define	FTInvalidConfigurationKey		(-21L)
#define	FTMemoryFullError				(-22L)
#define	FTInvalidServerStatus			(-23L)
#define	FTInvalidArgument				(-24L)
#define	FTUnresolvedService				(-25L)
#define	FTInvalidMask					(-26L)
#define	FTExceedSession					(-27L)
#define FTInvalidProfile				(-28L)
#define FTInvalidFilter					(-29L)
#define FTAccountNotActive				(-30L)		/* V323 */
#define FTTooManyTradersConnected		(-31L)		/* V323 */
#define FTPasswordExpired				(-32L)		/* V323 */
#define FTNotPrivilegeChangePassword	(-33L)		/* V323 */
#define FTNewPasswordRepeated			(-34L)		/* V323 */
#define FTInsufficientNewPasswordLength	(-35L)		/* V323 */
#define FTInvalidNewPasswordCharacters	(-36L)		/* V323 */
#define FTNewPasswordTooMuchEasy		(-37L)		/* V323 */
#define FTUnsupportedOperation			(-38L)		/* V330 */
#define FTSupersededOperation			(-39L)		/* V350 */


/* Trace Options */

#define FTTRACE_OPT_None				   (0)
#define FTTRACE_OPT_APIInOut			(1<<0)
#define FTTRACE_OPT_FlowControl			(1<<1)
#define FTTRACE_OPT_DataTransfert		(1<<2)
#define FTTRACE_OPT_DataIn				(1<<3)
#define FTTRACE_OPT_DataOut				(1<<4)
#define FTTRACE_OPT_Application			(1<<5)		/* V310 */

/* Filter sizes */

#define FT_FILTERDEF_MAXLEN				(1024)
#define FT_FILTERVAL_MAXLEN				(6144)



/* FTContext, conversation attributes */

#define CTX_COMPRESSED					(1)
#define CTX_APPL_AUTHKEY				(2)
#define CTX_APPL_AUTHFILE				(3)
#define CTX_X509_CERTIFICATE			(4)
#define CTX_CONNECTION_TIMEOUT			(5)			/* V310 */
#define CTX_CONNECTION_PROXYSTRING		(6)			/* V316 */
#define CTX_CONNECTION_NEWPASSWORD		(7)			/* V322 */

#define CTX_ALTERNATIVE_HOST1			(111)
#define CTX_ALTERNATIVE_PORT1			(112)
#define CTX_ALTERNATIVE_HOST2			(121)
#define CTX_ALTERNATIVE_PORT2			(122)
#define CTX_ALTERNATIVE_HOST3			(131)
#define CTX_ALTERNATIVE_PORT3			(132)


/* FTContext, initialization attributes */

#define CTX_INIT_MAX_BLOCK_LEN			(1000)


/* -----------------------
 ENUMS
----------------------- */

typedef enum {
	FTLevel_Undef,
	FTLevel_Full,
	FTLevel_Normal,
	FTLevel_Warning,
	FTLevel_Error
} FTTraceLevelEnum;

typedef enum {
	FTSource_Unused,
	FTSource_FTP,
	FTSource_API,
	FTSource_FlowControl,
	FTSource_DataTransfert,
	FTSource_Application							/* V310 */
} FTTraceSourceEnum;

typedef enum {
	FTUserUnused,
	FTUserTrader,
	FTUserAutoTrader,
	FTUserMonitor,
	FTUserView,
	FTUserController,
	FTUserMasterSlave
} FTUserTypeEnum;

typedef enum {
	FTConnectionLost,
	FTConnectionClosed
} FTBrokenTypeEnum;

typedef enum {
	FTSubscribeStart,
	FTSubscribeStop
} FTSubscribeStatusEnum;

typedef enum {
	FTAckUnrequired,
	FTAckRequired
} FTComunicationModeEnum;

typedef enum {
	FTFlowLast,
	FTFlowAll,
	FTZeroMaskedFlowLast,
	FTZeroMaskedFlowAll,
	FTDiffMaskedFlowAll				/* V321 */
} FTSubscribeFlowEnum;

typedef enum {
	FTQueryAll,
	FTQuerySet,
	FTQueryEQ,						/* deprecated */
	FTQueryLT,						/* deprecated */
	FTQueryGT,						/* deprecated */
	FTQueryBW,						/* deprecated */
	FTQueryPast,
	FTQueryOnTime
} FTQueryTypeEnum;

typedef enum {
	FTEntityADD,
	FTEntityDEL,
	FTEntityRWT,
	FTEntityKIL
} FTClassActionEnum;

typedef enum {
	FTClassInstance,
	FTConnectionBroken,
	FTClassIdle
} FTEventTypeEnum;

typedef enum {
	FTFlying,
	FTCommitted,
	FTLAborted,
	FTHAborted,
	FTNotManaged
} FTTransStatusEnum;

typedef enum {
	FTTransOK,
	FTTransNO,
	FTTransInvalSessionID,
	FTTransInvalidTID,
	FTTransPending,
	FTTransConversationClosed
} FTSendTransactionStatusEnum;

/* enum types */
typedef enum {
	FTFilterCreateOK,
	FTFilterCreateSyntaxError,
	FTFilterCreateInvalidFilterLen,
	FTFilterCreateInvalidClassID,
	FTFilterCreateInvalidFilterType,
	FTFilterCreateNotImplemented
} FTFilterCreateEnum;

typedef enum {
	FTFilterDestroyOK,
	FTFilterDestroyInvalidFilterID
} FTFilterDestroyEnum;

typedef enum {
	FTFilterSetOK,
	FTFilterSetSyntaxError,
	FTFilterSetInvalidFilterID,
	FTFilterSetInvalidFilterLen,
	FTFilterSetAlreadySet
} FTFilterSetEnum;

typedef enum {
	FTQueryOK,
	FTQueryBadParameters,
	FTQueryWrongQueryID,
	FTQueryGenericError
} FTQueryCreateEnum;

typedef enum {
	FTQueryRowsOK,
	FTQueryRowsWrongFirstRow,
	FTQueryRowsWrongRowNumber,
	FTQueryRowsWrongQueryID,
	FTQueryRowsGenericError
} FTQueryRowsEnum;

typedef enum {
	FTDestroyOK,
	FTDestroyWrongQueryID,
	FTDestroyError
} FTQueryDestroyEnum;

typedef enum {
	FTQueryRecOK,
	FTQueryRecNO,
	FTQueryRecGenericError
} FTQueryRecordEnum;

typedef enum {
	FTTransStatusOK,
	FTTransStatusNO,
	FTTransStatusInvalSessionID,
	FTTransStatusInvalidTID,
	FTTransStatusPending
} FTQueryTransStatusEnum;


/* -----------------------
 Data Types
----------------------- */

typedef void * FTContext;
typedef void * FTMask;
typedef void * FTDiffMask;								/* V321 */


/* -----------------------
 Structures
----------------------- */
typedef unsigned long FTTimeStamp[2];
typedef unsigned long FTRevision[3];

typedef struct{
	char buffer[FTKEY_MAXLEN];
	long len;
} FTKeyValue;

typedef struct {
	char						*UserName;
	unsigned long				BusinessServiceID;
	unsigned long				ClientServiceID;
	unsigned long				ClientID;
	unsigned long				SystemDate;
	unsigned long				SystemTime;
	FTRevision					MarketRevision;
	unsigned long				ReqID;
	unsigned long				FTID;
	unsigned long				Environment;
} FTOpenResStruct;

typedef struct {
	unsigned long				ClassID;
	FTSubscribeStatusEnum		SubscribeStatus;
	int							ResetClass;
	unsigned long				ClassVersion;
	FTSubscribeFlowEnum			SubscribeFlowEnum;
	FTQueryTypeEnum				QueryType;
	long						SubscriptionID;
} FTSubscribeResStruct;

typedef struct {
	FTClassActionEnum			EntityAction;
	unsigned long				ClassID;
	long						KeyID;
	FTTimeStamp					TimeStamp;
	void						*MarketObject;
	unsigned long				LenMarketObject;
	long						SubscriptionID;
	int							IsMasked;
	FTDiffMask					DiffMask;				/* V321 */
} FTNotifySubscribeResStruct;

typedef struct {
	unsigned long				BusinessServiceID;
	unsigned long				ClientServiceID;
	unsigned long				ClientID;
	unsigned long				TimeStamp[2];
} FTTransactionID;

typedef struct {
	FTSendTransactionStatusEnum	TransactionStatus;
	long						MarketReasonCode;
	unsigned long				ClassID;
	unsigned long				KeyID;
	FTClassActionEnum			EntityAction;
	FTTransactionID				TransactionID;
	FTTimeStamp					TimeStamp;
	long						ResultClassID;
	void						*ResultObject;
} FTSendTransactionResStruct;

typedef struct {
	unsigned long				ClassID;
	unsigned long				KeyID;
	FTClassActionEnum 			CA;
	FTTransactionID				TID;
	FTTransStatusEnum			Status;
	unsigned long  				MarketError;
	unsigned long  				NAMError;
	unsigned long  				LocalError;
} FTTransactionStateStruct;


/* struct types */

typedef struct {
	unsigned long				QueryKey;
	FTQueryCreateEnum			Result;
	int							CanComputeRowNumber;
	unsigned long				RowNumber;
	unsigned long				TimeToLive;
	int							ResultSetFollows;
} FTQueryCreateResStruct;

typedef struct {
	unsigned long				QueryKey;
	unsigned long				RowNumber;
	long						ClassID;
	void *						Entity;
	unsigned long				ClassVersion;			/* V308 */
	FTTimeStamp					TimeStamp;				/* V308 */
	unsigned long				Delete;					/* v328 */
	void 						*Info;					/* V308 */
	int							InfoSize;				/* V308 */
	int							EOQ;
} FTQueryNotifyStruct;

typedef struct {
	FTQueryTransStatusEnum		Result;
	long						ReasonCode;
	unsigned long				ClassID;
	unsigned long				KeyID;
	FTClassActionEnum 			ClassAction;
	FTTimeStamp					TimeStamp;
	unsigned long				ResClassID;
	void *						ResEntity;
} FTQueryTransStatusStruct;


/* -----------------------
 Function types
----------------------- */

typedef void (*FTLibraryTraceProc )			(long EventInfo, char *Message);
typedef void (*FTNotifySubscribeResProc)	(long ConversationID, FTEventTypeEnum EventType, FTNotifySubscribeResStruct *ResStruct);	/* superseded since V350 */
typedef void (*FTSubscribeResProc)			(long ConversationID, long ResultCode, FTSubscribeResStruct *ResStruct);					/* superseded since V350 */
typedef void (*FTOpenConversResProc)		(long ConversationID, long ResultCode, FTOpenResStruct *ResStruct);
typedef void (*FTNotifyBrokenProc)			(long ConversationID, FTBrokenTypeEnum BrokenType);
typedef void (*FTSendTransactionResProc)	(long ConversationID, FTSendTransactionResStruct *ResStruct);								/* superseded since V350 */
typedef void (*FTTransactionMonitorProc)	(long ConversationID, FTTransactionStateStruct *TransactionState);
typedef void (*FTConversationProc)			(long ConversationID, int IsWritePending);
typedef void (*FTConversationSocketProc)	(long ConversationID, int IsWritePending, long Socket);

/* function types */
typedef void (*FTNotifySubscribeResProcExt)	(long ConversationID, unsigned long ReqID, FTEventTypeEnum EventType, FTNotifySubscribeResStruct *ResStruct);
typedef void (*FTSubscribeResProcExt)		(long ConversationID, unsigned long ReqID, long ResultCode, FTSubscribeResStruct *ResStruct);
typedef void (*FTFilterCreateProc)			(long ConversationID, unsigned long ReqID, long FilterID, FTFilterCreateEnum Res);
typedef void (*FTFilterSetProc)				(long ConversationID, unsigned long ReqID, long FilterID, FTFilterSetEnum Res);
typedef void (*FTFilterDestroyProc)			(long ConversationID, unsigned long ReqID, long FilterID, FTFilterDestroyEnum Res);
typedef void (*FTQueryCreateProc)			(long ConversationID, unsigned long ReqID, FTQueryCreateResStruct *ResStruct);
typedef void (*FTQueryNotifyProc)			(long ConversationID, FTQueryNotifyStruct *QueryNotifyStruct);
typedef void (*FTQueryRowsProc)				(long ConversationID, unsigned long ReqID, unsigned long QueryKey, FTQueryRowsEnum Res);
typedef void (*FTQueryDestroyProc)			(long ConversationID, unsigned long ReqID, unsigned long QueryKey, FTQueryDestroyEnum Res);
typedef void (*FTSendTransactionResProcExt)	(long ConversationID, unsigned long ReqID, FTSendTransactionResStruct *ResStruct);
typedef void (*FTQueryTransStatusProc)		(long ConversationID, unsigned long ReqID, FTTransactionID *TransID, FTQueryTransStatusStruct *ResStruct);


/* -----------------------
 Functions
----------------------- */

FT_API long FTSetTraceMode				(	FTLibraryTraceProc				TraceProc,
											FTTraceLevelEnum				Level,
											long							Options,
											int								WriteFile,
											int								OldLogs,
											int								Flush);

FT_API void FTTraceAppl					(	FTTraceLevelEnum				level,
											char *							fmt,
																			...);				/* V310. Up to 10Kb messages */

FT_API long FTSetLicence				(	char *							Key);				/* superseded since V350 */
FT_API long FTLoadLicence				(	char *							KeyFile);			/* superseded since V350 */
FT_API long FTInit 						(	FTLibraryTraceProc				TraceProc);			/* superseded since V350 */
FT_API long FTExtendClass				(	void *							Sk);
FT_API long FTExtendClassByLibrary		(	char *							Path,
											char *							LibraryName,
											char **							LibraryVersion);	/* V310 */
FT_API long FTStart						(	void);
FT_API long FTShutdown					(	void);
FT_API long FTRun						(	void);
FT_API char *FTGetLibraryVersion		(	void);
FT_API char *FTGetErrorString			(	long							ErrCode);
FT_API int  FTCompareTS					(	FTTimeStamp						TS1,
											FTTimeStamp						TS2);

FT_API long FTGetTraceInfo				(	long							EventInfo,
											FTTraceSourceEnum *				Source,
											FTTraceLevelEnum *				Level);

FT_API long FTOpenConversation 			(	char *							IPAddress,
											unsigned short					IPPort,
											FTUserTypeEnum					UserType,
											unsigned long					ClientID,
											char *							UserName,
											char *							Password,
											FTRevision						ApplRevision,
											unsigned long					ApplSignature,
											FTOpenConversResProc			OpenResProc,
											FTOpenResStruct *				ResStruct,
											FTNotifyBrokenProc				BrokenProc);		/* superseded since V350 */

FT_API long FTCloseConversation			(	long							ConversationID);

FT_API long FTGetConversationSocket		(	long							ConversationID);
FT_API long FTEnumConversation			(	FTConversationProc				ConvProc);

FT_API long FTMakeKeyValue				(	long							ClassID,
											void *							Entity,
											long							KeyId,
											long							NumFields,
											FTKeyValue *					KeyValue);
FT_API long FTStartSubscribeClass		(	long							ConversationID,
											FTComunicationModeEnum			ComunicationMode,
											FTSubscribeFlowEnum				SubscribeFlow,
											unsigned long					ClassID,
											unsigned long					ClassVersion,
											FTTimeStamp						ClassTimeStamp,
											long							NotifyConversationID,
											FTQueryTypeEnum					QueryType,
											unsigned long					KeyID,
											FTKeyValue *					KeyValue1,
											FTKeyValue *					KeyValue2,
											FTSubscribeResProc				SubscrResProc,
											FTSubscribeResStruct *			ResStruct,
											FTNotifySubscribeResProc		NotifyResProc);		/* superseded since V350 */

FT_API long FTStopSubscribeClass		(	long							ConversationID,
											unsigned long					ClassID,
											long							SubscriptionID);

FT_API long FTStartTransactionMonitoring(	long							ConversationID,
											FTTransactionMonitorProc		MonitorProc);
FT_API long FTMakeTransactionID 		(	long							ConversationID,
											FTTransactionID *				TransactionID);
FT_API long FTSendTransaction 			(	long							ConversationID,
											FTTransactionID					TransactionID,
											FTClassActionEnum				Action,
											unsigned long					ClassID,
											unsigned long					KeyID,
											void *							MarketObject,
											FTSendTransactionResProc		ResProc,
											FTSendTransactionResStruct *	ResStruct);			/* superseded since V350 */

FT_API FTContext FTCreateContext		(	void);
FT_API long FTSetContextAttribute		(	FTContext						Context,
											long							Attribute,
											char *							Value);
FT_API void FTDestroyContext			(	FTContext						Context);

FT_API long FTOpenConversationExt		(	char * 							IPAddress,
											unsigned short					IPPort,
											FTUserTypeEnum					UserType,
											unsigned long					ClientID,
											char *							UserName,
											char * 							Password,
											FTRevision						ApplRevision,
											unsigned long					ApplSignature,
											FTOpenConversResProc			OpenResProc,
											FTNotifyBrokenProc				BrokenProc,
											unsigned long					ReqID,
											char *							Service,
											FTContext						Context);

FT_API FTMask FTCreateMask				(	unsigned long					ClassID);
FT_API void FTDestroyMask				(	FTMask							Mask);
FT_API long FTAddFieldToMask			(	FTMask							Mask,
											char *							Field);

FT_API long FTInitExt 					(	FTLibraryTraceProc				TraceProc,
											FTContext						Context);

FT_API long FTStartSubscribeClassExt	(	long							ConversationID,
											FTComunicationModeEnum			ComunicationMode,
											FTSubscribeFlowEnum				SubscribeFlow,
											unsigned long					ClassID,
											unsigned long					ClassVersion,
											FTTimeStamp						ClassTimeStamp,
											FTQueryTypeEnum					QueryType,
											unsigned long					KeyID,
											FTKeyValue *					KeyValue1,
											FTKeyValue *					KeyValue2,
											FTSubscribeResProcExt			SubscribeResProc,
											FTNotifySubscribeResProcExt		NotifyResProc,
											unsigned long					ReqID,
											unsigned long					FilterID,
											FTMask							SubscrMask);
FT_API long FTRefreshEntity				(	long							ConversationID,
											unsigned long					ClassID,
											long							SubscriptionID,
											void *							Entity,
											unsigned long					KeyID);

FT_API long FTFilterCreate				(	long							ConversationID,
											unsigned long					ReqID,
											unsigned long					ClassID,
											unsigned long					FilterType,
											unsigned long					FilterDefinitionLen,
											char *							FilterDefinition,		/* max len: FT_FILTERDEF_MAXLEN */
											FTFilterCreateProc				FilterCreateProc);
FT_API long FTFilterSet					(	long							ConversationID,
											unsigned long					FilterID,
											unsigned long					ReqID,
											unsigned long					FilterLen,
											char *			  				FilterVal,				/* max len: FT_FILTERVAL_MAXLEN */
											FTFilterSetProc					FilterSetProc);
FT_API long FTFilterDestroy				(	long							ConversationID,
											unsigned long					FilterID,
											unsigned long					ReqID,
											FTFilterDestroyProc				FilterDestroyProc);

FT_API long FTQueryCreate				(	long							ConversationID,
											unsigned long					QueryID,
											unsigned long					ReqID,
											unsigned long					ClassID,
											void *							Entity,
											FTQueryCreateProc				QueryCreateProc,
											FTQueryNotifyProc				QueryNotifyProc);
FT_API long FTQueryDestroy				(	long							ConversationID,
											unsigned long					QueryKey,
											unsigned long					ReqID,
											FTQueryDestroyProc				QueryDestroyProc);
FT_API long FTQueryRows					(	long							ConversationID,
											unsigned long					QueryKey,
											unsigned long					ReqID,
											unsigned long					FirstRow,
											unsigned long					RowNumber,
											FTQueryRowsProc					QueryRowsProc);
	
FT_API long FTSendTransactionExt		(	long							ConversationID,
											FTTransactionID *				TransID,
											FTClassActionEnum				Action,
											unsigned long					ClassID,
											unsigned long					KeyID,
											void *							MarketObject,
											FTSendTransactionResProcExt		ResProc,
											long							ResClassRequired,
											FTMask							MarketObjectMask,
											unsigned long					ReqID);
FT_API long FTQueryTransactionStatus	(	long							ConversationID,
											unsigned long					ReqID,
											FTTransactionID *				TransID,
											FTQueryTransStatusProc			ResProc,
											long							ResClassRequired);

FT_API long FTIsFieldChanged			(	unsigned long					Offset,					/* v321 */
											FTDiffMask						DiffMask);
FT_API long FTUpdateMarketObject		(	char							*CurrentMarketObject, 	/* v321 */
											char							*DiffMarketObject,
											FTDiffMask						DiffMask);

FT_API long FTConversationSocketSelect	(	long							ConversationID);		/* v330 */
FT_API long FTSocketSelect				(	void);													/* v330 */
FT_API void FTSetSelectTimeout			(	long Sec,
											long uSec);												/* v330 */

FT_API long FTMakeTransactionIDExt 		(	long							ConversationID,
											unsigned long					ClassID,
											FTTransactionID *				TransactionID);			/* v330 */

FT_API long FTEnumConversationSocket	(	FTConversationSocketProc		ConvSocketProc);		/* v332 */

#endif